// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class SessionsApi {
  SessionsApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Performs an HTTP 'GET /api/v1/Sessions' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<Response> getSessionsWithHttpInfo({
    required Object authorization,
  }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r'/api/v1/Sessions';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    headerParams[r'authorization'] = parameterToString(authorization);

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<List<SessionModel>> getSessions({
    required Object authorization,
  }) async {
    final response = await getSessionsWithHttpInfo(
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    final responseBody = await _decodeBodyBytes(response);
    return (await apiClient.deserializeAsync(responseBody, 'List<SessionModel>')
            as List)
        .cast<SessionModel>()
        .toList(growable: false);
  }
}
