// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class SessionModel {
  /// Returns a new [SessionModel] instance.
  SessionModel({
    required this.status,
    required this.date,
    required this.appointmentId,
  });

  final SessionStatusModel status;
  final DateTime date;
  final int appointmentId;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is SessionModel &&
          other.status == status &&
          other.date == date &&
          other.appointmentId == appointmentId;

  @override
  int get hashCode => status.hashCode + date.hashCode + appointmentId.hashCode;

  @override
  String toString() =>
      'SessionModel[status=$status, date=$date, appointmentId=$appointmentId]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'status'] = status;
    json[r'date'] = date.toUtc().toIso8601String();
    json[r'appointmentId'] = appointmentId;
    return json;
  }

  /// Returns a new [SessionModel] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static SessionModel fromJson(dynamic value) {
    final json = value.cast<String, dynamic>();
    return SessionModel(
      status: SessionStatusModel.fromJson(json[r'status']),
      date: mapDateTime(json, r'date', '')!,
      appointmentId: mapValueOfType<int>(json, r'appointmentId')!,
    );
  }

  static List<SessionModel> listFromJson(dynamic json) =>
      json is List && json.isNotEmpty
          ? json.map(SessionModel.fromJson).toList()
          : <SessionModel>[];

  static Map<String, SessionModel> mapFromJson(dynamic json) {
    final map = <String, SessionModel>{};
    if (json is Map && json.isNotEmpty) {
      json.cast<String, dynamic>().forEach(
          (key, dynamic value) => map[key] = SessionModel.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of SessionModel-objects as value to a dart map
  static Map<String, List<SessionModel>> mapListFromJson(dynamic json) {
    final map = <String, List<SessionModel>>{};
    if (json is Map && json.isNotEmpty) {
      json.cast<String, dynamic>().forEach((key, dynamic value) {
        map[key] = SessionModel.listFromJson(value);
      });
    }
    return map;
  }
}
